import propTypes from "prop-types";
import React, { useRef } from "react";
import { Link } from "react-router-dom";
import Search from "./Search";
import icon from "../../assets/logo/logo-large.svg";
import { useLocation } from "react-router-dom";
import account from "../../assets/icons/account.svg";
import logoLarge from "../../assets/logo/logo-large.svg";
import logoSmall from "../../assets/logo/logo-small.svg";
import mobileMenuToggleIcon from "../../assets/icons/mobile-toggle.svg";
import Images from "../composable-components/Images";
// Header Component takes in array property and renders them accordingly.

const Navbar = ({ navElements }) => {
  const ref = useRef();
  const location = useLocation();

  const setActiveNavLink = () => {
    let pageURL = window.location.pathname.substring(1);
    let links = document.querySelectorAll(".app_header nav ul li a");
    let linksMobile = document.querySelectorAll(".mobile-nav ul li a");
    links.forEach((el) => {
      if (pageURL == el.getAttribute("href").substring(1)) {
        el.classList.add("active");
      } else {
        el.classList.remove("active");
      }
    });
    linksMobile.forEach((el) => {
      if (pageURL == el.getAttribute("href").substring(1)) {
        el.classList.add("active");
      } else {
        el.classList.remove("active");
      }
    });
  };
  setActiveNavLink();

	window.addEventListener('DOMContentLoaded', (e) => {
		setActiveNavLink();
	});

  return (
    <>
      <div className="logo">
        <Link to="/">
          <img
            className="desktop-header-logo"
            src={logoLarge}
            alt="logo"
            loading="lazy"
          />
          <img
            className="mobile-header-logo"
            src={logoSmall}
            alt="logo"
            loading="lazy"
          />
        </Link>
      </div>
      <div className="desktop-nav-cont">
        <nav className="desktop-nav">
          <ul className="active">
            {navElements.map((li) => (
              <li key={li.text.toString()}>
                <Link to={{ pathname: li.link, state: location }}>
                  {li.text}
                </Link>
              </li>
            ))}
            <li>
              <Link to={{ pathname: "/profile" }}>
								<svg width="619" height="619" viewBox="0 0 619 619" fill="none" xmlns="http://www.w3.org/2000/svg">
									<path d="M133.65 454.019L136.5 413.685C137.107 404.474 137.456 400.356 138.946 394.271C140.104 389.4 141.593 383.167 145.988 376.347C150.106 369.857 154.721 366.07 160.532 361.327C164.724 357.871 168.99 354.488 175.02 351.253C179.213 348.955 181.713 348.072 188.829 345.701L206.094 339.873C208.263 339.064 209.808 338.513 213.945 337.226C218.284 335.866 221.263 335.057 223.69 334.376C227.551 333.292 229.518 332.814 233.104 331.472C236.211 330.314 240.679 328.494 244.007 326.471C246.232 325.056 248.751 323.493 251.325 320.717C253.09 318.824 255.039 316.654 255.241 315.717C255.37 314.834 254.506 312.812 253.752 310.974C253.145 309.411 252.943 309.154 250.498 306.102C248.402 303.455 246.434 300.899 243.805 297.296C238.326 289.648 235.678 285.733 233.049 280.236C230.677 275.162 228.912 269.61 226.411 254.793C224.315 242.604 222.954 234.552 222.274 222.786C221.87 215.819 221.392 206.884 222.274 195.523C223.285 182.801 224.039 173.591 228.912 162.358C235.476 147.339 245.294 138.68 248.935 135.426C267.064 119.395 286.627 116.141 298.34 114.174C310.181 112.207 322.371 110.185 337.522 114.652C353.426 119.248 367.087 129.396 378.193 144.691C389.354 160.116 392.13 174.878 395.587 193.611C397.812 205.524 399.724 215.745 398.437 229.809C396.947 246.391 392.204 261.687 384.297 275.07C382.073 278.931 379.903 281.964 377.605 285.218C374.957 288.931 371.923 293.197 367.455 301.046C364.146 306.874 363.392 308.896 363.061 311.599C362.858 313.29 362.38 316.673 364.072 320.129C365.69 323.512 368.669 325.332 371.794 327.225C373.21 328.034 379.921 330.332 385.327 332.097C392.02 334.395 398.657 336.435 405.571 338.458C407.667 339.064 412.815 340.48 419.508 342.245L428.039 344.267C431.091 344.947 432.783 345.352 436.221 346.436C446.371 349.69 453.339 353.33 458.818 358.202C461.19 360.224 463.562 362.743 465.658 365.519C468.637 369.379 470.862 373.369 473.234 378.921C475.403 384.197 477.297 390.153 478.989 397.249C480.404 403.482 481.691 410.449 482.648 417.417C483.328 422.969 483.806 428.447 484.063 433.925L484.744 450.361L468.435 452.181L133.65 454.019ZM318.804 146.953C313.932 146.953 309.261 147.835 304.113 148.717C294.57 150.335 282.729 152.302 272.175 161.568C269.877 163.59 264.453 168.407 260.941 176.385C258.496 181.992 258.036 186.809 257.08 198.244C256.345 207.656 256.804 215.028 257.08 220.433C257.687 230.93 258.9 237.953 260.739 248.524C263.037 261.981 264.122 264.297 264.655 265.382C266.347 269.04 268.369 271.669 272.231 277.019C274.603 280.328 276.349 282.571 277.783 284.336C280.762 288.123 283.465 291.505 285.965 297.462C288.062 302.462 291.445 310.79 289.68 321.489C287.786 332.648 281.35 339.689 277.03 344.359C271.201 350.72 265.464 354.231 262.412 356.125C258.22 358.772 252.539 361.474 245.368 364.177C240.422 366.07 237.719 366.824 234.133 367.762C231.633 368.442 228.857 369.177 224.389 370.611L201.994 378.185C195.503 380.281 194.069 380.612 191.715 381.972C187.928 383.995 185.427 386.164 182.706 388.407C177.558 392.598 176.473 393.554 175.462 395.172C174.303 396.992 173.899 398.481 172.888 402.618C171.876 406.68 171.803 409.309 171.472 415.744L171.269 418.795L447.235 417.38C446.555 413.188 445.819 409.125 444.937 405.394C443.171 398.15 441.48 393.959 440.873 392.396C439.66 389.344 438.851 388.057 437.894 386.789C437.214 385.907 436.405 385.098 435.596 384.362C434.033 383.002 430.448 381.311 425.447 379.766C423.553 379.16 422.542 378.957 420.979 378.608C418.754 378.13 415.904 377.45 410.701 376.108C403.125 374.141 397.297 372.45 395.752 371.99C388.508 369.894 381.411 367.651 374.24 365.298C363.612 361.713 358.262 359.949 353.739 357.117C348.866 354.139 338.846 348.054 332.686 335.461C326.526 322.666 327.942 311.102 328.42 307.315C329.579 297.645 333.219 290.678 337.154 283.839C342.504 274.427 346.163 269.353 349.344 264.885C351.036 262.459 352.599 260.345 354.29 257.44C359.567 248.432 362.748 238.155 363.759 226.794C364.568 217.528 363.355 210.69 361.388 200.339C358.004 182.268 356.313 174.014 349.951 165.281C347.322 161.623 340.28 151.88 327.814 148.221C324.761 147.357 321.985 146.953 318.804 146.953Z" fill="#F8951D" stroke="#F89521" strokeWidth="15" strokeMiterlimit="10"/>
									<path d="M574.489 333.623C563.862 443.118 485.295 538.586 378.23 566.731C268.811 595.484 152.276 551.914 88.1802 458.799C24.8381 366.843 28.2948 240.435 94.211 150.979C159.98 61.7256 278.482 21.3361 384.922 53.4712C491.51 85.6062 567.649 181.772 575.224 292.738C576.181 306.342 575.703 320.019 574.489 333.623C572.393 357.853 610.012 361.365 612.182 337.08C623.287 210.267 553.51 88.4741 438.74 33.6533C324.504 -20.8917 182.246 4.14717 93.3836 94.2099C3.45444 185.486 -21.3859 326.785 35.2634 442.419C91.4346 557.117 215.545 624.916 342.376 611.662C466.081 598.738 573.956 505.55 603.871 384.712C607.787 369.012 610.637 353.11 612.2 337.006C614.553 312.85 576.842 309.32 574.489 333.623Z" fill="#F8951D"/>
									<path d="M574.489 333.623C563.862 443.118 485.295 538.586 378.23 566.731C268.811 595.484 152.276 551.914 88.1802 458.799C24.8381 366.843 28.2948 240.435 94.211 150.979C159.98 61.7256 278.482 21.3361 384.922 53.4712C491.51 85.6062 567.649 181.772 575.224 292.738C576.181 306.342 575.703 320.019 574.489 333.623ZM574.489 333.623C572.393 357.853 610.012 361.365 612.182 337.08C623.287 210.267 553.51 88.4741 438.74 33.6533C324.504 -20.8917 182.246 4.14717 93.3836 94.2099C3.45444 185.486 -21.3859 326.785 35.2634 442.419C91.4346 557.117 215.545 624.916 342.376 611.662C466.081 598.738 573.956 505.55 603.871 384.712C607.787 369.012 610.637 353.11 612.2 337.006C614.553 312.85 576.842 309.32 574.489 333.623Z" stroke="#F89521" strokeWidth="10" strokeMiterlimit="10"/>
								</svg>
              </Link>
            </li>
          </ul>
          <Search screenType={1} />
        </nav>
      </div>
      <div className="mobile-nav-cont">
        <div className="mobile-nav-toggle-btn-cont">
          <button
            role="button"
            aria-label="toggle mobile nav"
            title="toggle mobile nav"
            type="button"
            className="mobile-nav-toggle-btn"
            onClick={(e) =>
              document.querySelector(".mobile-nav").classList.toggle("active")
            }
          >
						<svg id="mobile-nav-toggle-btn-svg" width="33" height="25" viewBox="0 0 33 25" fill="none" xmlns="http://www.w3.org/2000/svg" alt="mobile menu toggle" aria-label="mobile toggle icon">
							<path d="M1.71875 12.5H31.2812" stroke="black" strokeWidth="3" strokeLinecap="round" strokeLinejoin="round"/>
							<path d="M1.71875 1.75H31.2812" stroke="black" strokeWidth="3" strokeLinecap="round" strokeLinejoin="round"/>
							<path d="M1.71875 23.25H31.2812" stroke="black" strokeWidth="3" strokeLinecap="round" strokeLinejoin="round"/>
						</svg>
          </button>
        </div>
        <Search screenType={2} />
      </div>
    </>
  );
};

Navbar.propTypes = {
  navElements: propTypes.array,
};

Navbar.defaultProps = {
  navElements: ["Home", "About"],
};

export default Navbar;
